package TreeStore::Object;
use strict;
use vars qw(@ISA $AUTOLOAD);
use TreeStore;

sub __{
    my($self) = shift;
    local($_);
    if(scalar(@_) > 0){
	if(not defined($_[0])){
	    # remove object.
	    my(%list);
	    map {$list{$_} = 1} $self->{base}->read_dir($self);
	    delete $list{"."};
	    delete $list{".."};
	    grep {$self->$_(undef);} keys %list;
	    rmdir($self->{path});
	}else{
	    # return listed childs
	    return grep {$_ = $self->$_();} @_;
	}
    }
    if(wantarray){
	return $self->{base}->read_dir($self);
    }else{
	return $self;
    }
}

sub __timestamp{
    my $self = shift;
    if(scalar(@_) == 0){
	@_ = $self->__();
    }
    my $result = 0;;
    foreach my $target (@_){
	my $timestamp = (stat($self->{path}."/".$target))[9];
	$result = $timestamp if ($timestamp > $result);
    }
    return $result;
}

sub AUTOLOAD{
    my($self) = shift;
    my($class,$method) = $AUTOLOAD =~ /^(.+)::([^:]+)$/;

    my($base) = $self->{base};
    my($path) = $base->join_path($self->{path},$method);
    my $child = $base->read($path);
    if($child->{Type} == TreeStore::UNDEF() && scalar(@_) == 0){
	if(wantarray){
	    return ();
	}else{
	    return bless {path => $child->{path},
			  base => $child->{base},
			  Type => $child->{Type} };
	}
    }
    if($child->{Type} == TreeStore::PROPERTY()
        or $child->{Type} == TreeStore::UNDEF() ){
	#if $child is property(file)
	if(scalar(@_) > 0){
	    # Modify Property
	    if(not defined($_[0])){
		$child->{value}  = undef;
		$child->{Modify} = 'delete';
		#delete file
	    }else{
		$child->{value}  = \@_;
		$child->{Modify} = 'write';
	    }
	    return $base->{cache}->{$path}->{value};
	}else{
	    # Fetch Property
	    if(wantarray){
		return @{$child->{value}};
	    }else{
		return join("\n",@{$child->{value}});
	    }
	}
    }elsif($child->{Type} == TreeStore::OBJECT()){
	if(scalar(@_) > 0){
	    if(not defined($_[0])){
		$child->{Modify} = 'delete';
	    }
	}
	if(wantarray){
	    return $base->read_dir($child);
	}else{
	    return bless {path => $child->{path},
			  base => $child->{base},
			  Type => $child->{Type} };
	}
    }
}

sub DESTROY{
    my($self) = shift;
    my $base = $self->{base};
    foreach(keys %{$base->{cache}}){
	$_ = $base->{cache}->{$_};
    }
}

1;
